//import waba.fx.*;     // ?
//import waba.io.*;
import waba.sys.*;    // Time
import waba.ui.*;
//import waba.util.*;
import extra.ui.*;  // !!!b. wextras: List (Popup, RelativeContainer, PreferredSize), Title
// Random, TimeUtil (StringUtil)

/**
 * @author <A HREF="mailto:weyer@kagi.com">Steve Weyer</A>
 * Copyright (c) 2001, S. Weyer. All right reserved.
 * @version waba 1.0
 * !!!c 08 Feb 2001 inputChoices init with choiceNames directly
 * !!!b 17 Jan 2001: wextras. updated dates
 * !!!a 25 Nov 2000
 * <A HREF="http://www.kagi.com/weyer/#CountDown">Steve's other CountDown versions</A>
 * <A HREF="http://www.kagi.com/weyer/#Waba">Steve's other Waba apps</A>
 *
 * ! Newton: classheap: 22000
 * ?? eliminate flicker?  (use repaint/drawText instead of setText)
 * ?? font metrics for Palm, WinCE?
**/

public class CountDown extends MainWindow {
  static final boolean DEBUG = false;
  private static final String undate = "???w ??d ??h ??m ??s";

  private static final int COMPHT = 15;

  private Label nowVal;
  private List inputChoices;
  private Edit newInput;
  private Label waitVal;

  private Time setDate;
  private Random rand;

  private static final String [] choiceDates = { // coord with choiceNames
    null,
    "29 Sep 2001",
    "25 Dec 2001",
    "1 Jan 2002",
    //null,
  };

  private static final String [] choiceNames = { // coord with choiceDates
    "(Use Field)",    // first
    "Ellie's Birthday '01",
    "Christmas '01",
    "1/1/2002",
    "End of World?",  // last
  };

  public CountDown() {
    int objX = 0, objY = 0, objWid = this.width;

    Title title = new Title("Ellie's CountDown");
    title.setRect(objX, objY, objWid, COMPHT);
    add(title);

    objY += COMPHT;
    Label lbl = new Label("Now:");
    lbl.setRect(objX, objY, objWid, COMPHT);
    add(lbl);

    objY += COMPHT;
    nowVal = new Label(TimeUtil.toString(new Time()));
    nowVal.setRect(objX, objY, objWid, COMPHT);
    nowVal.addTimer(1000);
    add(nowVal);

    objY += COMPHT;
    lbl = new Label("Until:");
    lbl.setRect(objX, objY, objWid, COMPHT);
    add(lbl);

    objY += COMPHT;
    inputChoices = new List(choiceNames);
    inputChoices.setRect(objX, objY, objWid, COMPHT);
    add(inputChoices);

    objY += COMPHT;
    newInput = new Edit();
    newInput.setRect(objX, objY, objWid, COMPHT);
    add(newInput);

    objY += COMPHT;
    lbl = new Label("You'll have to wait:");
    lbl.setRect(objX, objY, objWid, COMPHT);
    add(lbl);

    objY += COMPHT;
    waitVal = new Label(undate);
    waitVal.setRect(objX, objY, objWid, COMPHT);
    add(waitVal);

    // bottom row
    objY = this.height - COMPHT;
    objWid = 40; // for Quit
    objX = this.width - objWid;
    lbl = new Label("weyer@kagi.com");
    lbl.setRect(0, objY, objX, COMPHT);
    add(lbl);

    rand = new Random();
  }


   private void updateDate() {
    Time now = new Time();
    nowVal.setText(TimeUtil.toString(now));

    if (setDate != null) {
      int days = TimeUtil.dayDiff(now, setDate);
      int secs = TimeUtil.secDiff(now, setDate);
      //if (DEBUG) System.out.println("diff days: " + days + "; secs: " + secs);
      int wks = days / 7;
      days %= 7;
      int hrs = secs / 3600;
      secs %= 3600;
      int mins = secs / 60;
      secs %= 60;
      waitVal.setText(
        wks  + "w " + days + "d " + hrs + "h " +
        mins + "m " + secs + "s");
      };
  }

  public void onEvent(Event ev) {
    Object obj = ev.target;
    int evType = ev.type;
    if (evType == ControlEvent.TIMER)
      updateDate();
    else if (evType == ControlEvent.PRESSED) {
      if (obj == inputChoices) {
        if (DEBUG) System.out.println("Date: " + inputChoices.getSelected());
        int item = inputChoices.getSelectedIndex();
        if (item == 0)
          // convert user input
          setDate = TimeUtil.fromString(newInput.getText());
        else if (item < choiceDates.length)
          // existing menu date
          setDate = TimeUtil.fromString(choiceDates[item]);
        else {
          // random date in next ~10+ years
          setDate = new Time();
          setDate.year = setDate.year + 1 + rand.getRandom(10); // 200x-
          int mon = rand.getRandom(12) + 1; // 1-12
          setDate.month = mon;
          setDate.day = 1 + rand.getRandom(TimeUtil.daysInMonth(setDate.year, mon)); // 1-N
          setDate.hour   = rand.getRandom(24);  // 0-23
          setDate.minute = rand.getRandom(60);  // 0-59
          setDate.second = rand.getRandom(60);  // 0-59
          };
        if (setDate == null)
          waitVal.setText(undate);  // !!!b
        else {
          if (DEBUG) System.out.println(TimeUtil.toString(setDate));
          newInput.setText(TimeUtil.toString(setDate));
        };
      };
    };
  }
}
